diff --git a/pgadmin/debugger/dlgDirectDbg.cpp b/pgadmin/debugger/dlgDirectDbg.cpp
index 2e1ef87..bb62988 100644
--- a/pgadmin/debugger/dlgDirectDbg.cpp
+++ b/pgadmin/debugger/dlgDirectDbg.cpp
@@ -62,855 +63,990 @@ END_EVENT_TABLE()
 //  EXEC statement that invokes the target (with the parameter values
 //  provided by the user).
 
-dlgDirectDbg::dlgDirectDbg( frmDebugger *parent, wxWindowID id, const dbgConnProp &connProp )
-	: m_connProp(connProp),
-	  m_targetInfo(NULL),
-	  m_conn(NULL),
-	  m_codeWindow(NULL),
-	  m_parent (parent),
-	  m_cancelled (false)
+dlgDirectDbg::dlgDirectDbg(frmDebugger *_parent, dbgController *_controller,
+                           pgConn *_conn)
+	: m_controller(_controller), m_thread(NULL), m_conn(_conn)
 {
+	int width,height, totalWidth=0;
 	wxWindowBase::SetFont(settings->GetSystemFont());
-	LoadResource(m_parent, wxT("dlgDirectDbg"));
+	LoadResource(_parent, wxT("dlgDirectDbg"));
 
 	// Icon
 	SetIcon(*debugger_png_ico);
 	RestorePosition();
-}
 
-////////////////////////////////////////////////////////////////////////////////
-// setupParamWindow()
-//
-//    This function lays out the parameter prompt window.  It contains a grid that
-//  displays the name and type of each IN (and IN/OUT) parameter and a place to
-//  enter a value for each of those parameters.  It also contains an OK button
-//    and a CANCEL button
-
-void dlgDirectDbg::setupParamWindow( )
-{
-	// Add three columns to the grid control:
-	//   (Parameter) Name, Type, and Value
-	grdParams->CreateGrid( 0, 3 );
-	grdParams->SetColLabelValue( COL_NAME,  _( "Name" ));
-	grdParams->SetColLabelValue( COL_TYPE,  _( "Type" ));
-	grdParams->SetColLabelValue( COL_VALUE, _( "Value" ));
-	grdParams->SetRowLabelSize( 25 );
-	grdParams->SetColSize( 0, 75 );
-	grdParams->SetColSize( 1, 100 );
-	grdParams->SetColSize( 2, grdParams->GetClientSize().x - 210 );
-	grdParams->SetColLabelSize( 18 );
+	grdParams->SetRowLabelSize(wxGRID_AUTOSIZE);
+	grdParams->SetColLabelSize(20);
+	grdParams->AutoSizeColumns(true);
 
 	chkPkgInit->SetValue(false);
-	chkPkgInit->Disable();
-}
 
-////////////////////////////////////////////////////////////////////////////////
-// startDebugging()
-//
-//    This function initializes *this with information about the target function
-//  (or procedure), constructs a grid that prompts the user for parameter values,
-//  and then displays the prompt dialog to the user.  Call this function after
-//  you construct a dlgDirectDbg (obviously) when you're ready to display the
-//  prompt dialog to the user.
+	PopulateParamGrid();
 
-bool dlgDirectDbg::startDebugging( void )
-{
-	// First, figure out what kind of target we are going to debug.
-	// The caller filled in our m_breakpoint list with the name and
-	// type of each target that he's interested in.
-	//
-	// FIXME: For now, we only allow one initial breakpoint for direct
-	//          debugging - you can create other breakpoints once you see
-	//          the source code.
+	LoadSettings();
 
-	dbgBreakPointList::Node *node = m_breakpoints.GetFirst();
+	for(int i=0;i<7;i++)
+		grdParams->AutoSizeColumn(i, true);
 
-	wxASSERT_MSG( node != NULL, wxT( "Expected to find at least one target on the command line" ));
-
-	dbgBreakPoint *breakpoint = node->GetData();
-
-	m_target = breakpoint->getTarget();
-
-	char    targetType = 0;
-
-	switch( breakpoint->getTargetType())
+	// Extend grid to it's parent width.
+	
+	grdParams->GetClientSize(&width, &height);
+	for (int i = 0; i<6; i++)
 	{
-		case dbgBreakPoint::TRIGGER:
-			targetType = 't';
-			break;
-		case dbgBreakPoint::FUNCTION:
-			targetType = 'f';
-			break;
-		case dbgBreakPoint::PROCEDURE:
-			targetType = 'p';
-			break;
-		case dbgBreakPoint::OID:
-			targetType = 'o';
-			break;
-		default:
-		{
-			wxASSERT_MSG( false, wxT( "Unexpected target type" ));
-			break;
-		}
+		totalWidth += grdParams->GetColumnWidth(i);
 	}
-
-	if (!loadTargetInfo( m_target, m_connProp, targetType ))
-		return false;
-
-	populateParamGrid();
-	return true;
+	grdParams->SetColumnWidth(COL_DEF_VAL,width-totalWidth-100); // Total client width - total six column widths - the first (an empty) column width.
 }
 
+
 ////////////////////////////////////////////////////////////////////////////////
-// loadTargetInfo()
+// PopulateParamGrid()
+//
+//    This function reads parameter descriptions from m_targetInfo and adds a
+//    new row to the grid control for each IN (or IN/OUT, VARAIADIC) parameter.
+//    Each row displays the parameter name, the data type, and an entry box
+//    where the user can type in a value for that parameter
 //
-//    This function establishes a connection to the server and creates a new
-//  dbgTargetInfo object that loads information about the debug target (that is,
-//  the function or procedure of interest).  Call this function with two
-//  arguments: target should contain the signature of a function or procedure
-//  or the OID of a function or procedure and connProp should contain the
-//  information required to connect to the server (like the hostname, port number,
-//  and user name).
-
-bool dlgDirectDbg::loadTargetInfo( const wxString &target, const dbgConnProp &connProp, char targetType )
+void dlgDirectDbg::PopulateParamGrid()
 {
-	// Connect to the server using the connection properties contained in connProp
+	pgDbgArgs *args = m_controller->GetTargetInfo()->GetArgs();
 
-	m_conn = new dbgPgConn(m_parent, connProp);
+	// If the target is defined within package, offer the user
+	// a chance to debug the initializer (there may or may not
+	// be an initializer, we don't really know at this point)
+	if(m_controller->GetTargetInfo()->GetPkgOid() == 0)
+		chkPkgInit->Disable();
+	else
+		chkPkgInit->Enable();
 
-	if( m_conn && m_conn->isConnected())
+	if (!args)
 	{
-		if( getenv( "DEBUGGER_INIT" ))
-		{
-			PQclear( m_conn->waitForCommand( wxString(getenv( "DEBUGGER_INIT" ), wxConvUTF8 )));
-		}
+		grdParams->SetColLabelValue(COL_NAME, _("No arguments required"));
+		grdParams->SetColSize(0, 350);
+		return;
+	}
 
-		// Our proxy API may throw (perfectly legitimate) errors at us (for example,
-		// if the target process ends while we are waiting for a breakpoint) - apparently
-		// those error messages scare the user when they show up in the log, so we'll
-		// just suppress logging for this session
+	// Add seven columns to the grid control:
+	// - Name, Type, NULL?, EXPR?, Value, Default?, And Default Value
+	grdParams->CreateGrid(0, 7);
 
-		PQclear( m_conn->waitForCommand( wxT( "SET log_min_messages TO fatal" )));
+	grdParams->SetColLabelValue(COL_NAME, _("Names"));
+	grdParams->SetColLabelValue(COL_TYPE, _("Type"));
+	grdParams->SetColLabelValue(COL_NULL, _("Null?"));
+	grdParams->SetColLabelValue(COL_EXPR, _("Expr?"));
+	grdParams->SetColLabelValue(COL_VALUE, _("Value"));
+	grdParams->SetColLabelValue(COL_USE_DEF, _("Default?"));
+	grdParams->SetColLabelValue(COL_DEF_VAL, _("Default Value"));
 
-		// Now load information about the target into m_targetInfo (note:
-		// the dbgTargetInfo() constructor queries the server for all
-		// required information)
+	size_t idx = 0;
 
-		try
-		{
-			m_targetInfo = new dbgTargetInfo( target, m_conn, targetType );
-		}
-		catch( const std::runtime_error &error )
-		{
-			wxLogError(wxT("%s"), wxString(error.what(), wxConvUTF8).c_str());
-			m_conn->Close();
-			return false;
-		}
+	for(size_t pIdx = 0; pIdx < args->Count(); pIdx++)
+	{
+		dbgArgInfo *arg = (*args)[pIdx];
 
-		this->SetTitle(m_targetInfo->getName());
-	}
+		// If this is an IN parameter (or an IN/OUT parameter), add
+		// a new row to the grid
+		if(arg->GetMode() != pgParam::PG_PARAM_OUT)
+		{
+			grdParams->AppendRows(1);
+			grdParams->SetCellValue(idx, COL_NAME,  arg->GetName());
 
-	return true;
-}
+			// Make it obvious which are variadics
+			if (arg->GetMode() != pgParam::PG_PARAM_VARIADIC)
+			{
+				grdParams->SetRowLabelValue(idx, wxEmptyString);
+				grdParams->SetCellValue(idx, COL_TYPE, arg->GetTypeName());
 
-////////////////////////////////////////////////////////////////////////////////
-// populateParamGrid()
-//
-//    This function reads parameter descriptions from m_targetInfo and adds a new
-//  row to the grid control for each IN (or IN/OUT) parameter.  Each row displays
-//    the parameter name, the data type, and an entry box where the user can type
-//  in a value for that parameter
+				if (!arg->IsArray())
+				{
+					// Is the value an expression?
+					grdParams->SetCellEditor(idx, COL_EXPR, new ctlGridCellBoolEditor());
+					grdParams->SetCellRenderer(idx, COL_EXPR, new wxGridCellBoolRenderer());
+					grdParams->SetCellValue(idx, COL_EXPR, wxT(""));
+				}
+				else
+				{
+					grdParams->SetCellBackgroundColour(idx, COL_EXPR, wxColour(235, 235, 235, 90));
+					grdParams->SetCellBackgroundColour(idx, COL_VALUE, wxColour(235, 235, 235, 90));
+				}
 
-void dlgDirectDbg::populateParamGrid( )
-{
-	// First, try to load default values from a previous invocation into
-	// m_targetInfo (assuming that we're debugging the same target this
-	// time around)
+				// Use the default value?
+				grdParams->SetCellRenderer(idx, COL_USE_DEF, new wxGridCellBoolRenderer());
+				grdParams->SetCellEditor(idx, COL_USE_DEF, new ctlGridCellBoolEditor());
+			}
+			else
+			{
+				grdParams->SetCellValue(idx, COL_TYPE, wxT("VARIADIC ") + arg->GetTypeName());
+				grdParams->SetRowLabelValue(idx, wxEmptyString);
 
-	loadSettings();
+				grdParams->AppendRows(1);
+				grdParams->SetRowLabelValue(idx + 1, wxT("+"));
+				grdParams->SetCellValue(idx + 1, COL_NAME, _("Click '+/-' to add/remove value to variadic"));
 
-	int i = 0;
+				grdParams->SetCellBackgroundColour(idx + 1, COL_EXPR,    wxColour(235, 235, 235, 90));
+				grdParams->SetCellBackgroundColour(idx + 1, COL_VALUE,   wxColour(235, 235, 235, 90));
+				grdParams->SetCellBackgroundColour(idx + 1, COL_USE_DEF, wxColour(235, 235, 235, 90));
+			}
 
-	for( int count = 0; count < m_targetInfo->getArgCount(); ++count )
-	{
-		wsArgInfo &arg = ((*m_targetInfo)[count] );
+			// Set value to NULL?
+			grdParams->SetCellEditor(idx, COL_NULL, new ctlGridCellBoolEditor(arg));
+			grdParams->SetCellRenderer(idx, COL_NULL, new wxGridCellBoolRenderer());
+			grdParams->SetCellValue(idx, COL_NULL, wxT(""));
 
-		// If this is an IN parameter (or an IN/OUT parameter), add
-		// a new row to the grid
+			if (arg->HasDefault())
+			{
+				// Whenever the default value is available, use that by default
+				grdParams->SetCellValue(idx, COL_USE_DEF, wxT("1"));
+				grdParams->SetCellValue(idx, COL_DEF_VAL, arg->Default());
+
+				// When "Use Defalut?" is enabled, disable VALUE, NULL? and
+				// EXPR? columns
+				grdParams->SetReadOnly(idx, COL_USE_DEF, false);
+				grdParams->SetReadOnly(idx, COL_VALUE, false);
+				grdParams->SetReadOnly(idx, COL_EXPR, false);
+			}
+			else
+			{
+				grdParams->SetCellValue(idx, COL_USE_DEF, wxT(""));
+				grdParams->SetCellValue(idx, COL_DEF_VAL, wxT("-- NO DEFAULT VALUE --"));
 
-		if( arg.getMode() != wxT( "o" ))
-		{
-			grdParams->AppendRows( 1 );
-			grdParams->SetCellValue( i, COL_NAME,  arg.getName());
+				// When default value is not available, we should ask the user
+				// to enter them
+				grdParams->SetReadOnly(idx, COL_USE_DEF, true);
+				grdParams->SetReadOnly(idx, COL_VALUE, arg->IsArray());
+				grdParams->SetReadOnly(idx, COL_EXPR, arg->IsArray());
 
-			// Make it obvious which are variadics
-			if (arg.getMode() != wxT( "v" ))
-				grdParams->SetCellValue( i, COL_TYPE,  arg.getType());
-			else
-				grdParams->SetCellValue( i, COL_TYPE, arg.getType() + wxT(" VARIADIC"));
+				grdParams->SetCellBackgroundColour(idx, COL_USE_DEF, wxColour(235, 235, 235, 90));
+				if (arg->IsArray())
+				{
+					grdParams->SetCellBackgroundColour(idx, COL_VALUE, wxColour(235, 235, 235, 90));
+					grdParams->SetCellBackgroundColour(idx, COL_EXPR, wxColour(235, 235, 235, 90));
+				}
+			}
 
-			grdParams->SetCellValue( i, COL_VALUE, arg.getValue());
+			grdParams->SetReadOnly(idx, COL_NULL, false);
+			grdParams->SetReadOnly(idx, COL_NAME, true);
+			grdParams->SetReadOnly(idx, COL_TYPE, true);
+			grdParams->SetReadOnly(idx, COL_DEF_VAL, true);
+			grdParams->SetCellBackgroundColour(idx, COL_NAME,    wxColour(235, 235, 235, 90));
+			grdParams->SetCellBackgroundColour(idx, COL_TYPE,    wxColour(235, 235, 235, 90));
+			grdParams->SetCellBackgroundColour(idx, COL_DEF_VAL, wxColour(235, 235, 235, 90));
 
-			grdParams->SetReadOnly( i, COL_NAME,  true );
-			grdParams->SetReadOnly( i, COL_TYPE,  true );
-			grdParams->SetReadOnly( i, COL_VALUE, false );
+			idx++;
 
-			i++;
+			if (arg->GetMode() != pgParam::PG_PARAM_VARIADIC &&
+			        arg->IsArray())
+			{
+				grdParams->AppendRows(1);
+
+				grdParams->SetRowLabelValue(idx, wxT("+"));
+				grdParams->SetCellValue(idx, COL_NAME, _("Click '+/-' to add/remove value to the array"));
+
+				grdParams->SetReadOnly(idx, COL_NAME,    true);
+				grdParams->SetReadOnly(idx, COL_TYPE,    true);
+				grdParams->SetReadOnly(idx, COL_NULL,    true);
+				grdParams->SetReadOnly(idx, COL_EXPR,    true);
+				grdParams->SetReadOnly(idx, COL_VALUE,   true);
+				grdParams->SetReadOnly(idx, COL_USE_DEF, true);
+				grdParams->SetReadOnly(idx, COL_DEF_VAL, true);
+
+				grdParams->SetCellBackgroundColour(idx, COL_NAME,    wxColour(235, 235, 235, 90));
+				grdParams->SetCellBackgroundColour(idx, COL_TYPE,    wxColour(235, 235, 235, 90));
+				grdParams->SetCellBackgroundColour(idx, COL_NULL,    wxColour(235, 235, 235, 90));
+				grdParams->SetCellBackgroundColour(idx, COL_EXPR,    wxColour(235, 235, 235, 90));
+				grdParams->SetCellBackgroundColour(idx, COL_VALUE,   wxColour(235, 235, 235, 90));
+				grdParams->SetCellBackgroundColour(idx, COL_USE_DEF, wxColour(235, 235, 235, 90));
+				grdParams->SetCellBackgroundColour(idx, COL_DEF_VAL, wxColour(235, 235, 235, 90));
+
+				idx++;
+			}
 		}
 	}
 
 	// Move the cursor to the first value (so that the user
 	// can just start typing)
 
-	grdParams->SetGridCursor( 0, COL_VALUE );
+	grdParams->SetGridCursor(0, COL_VALUE);
 	grdParams->SetFocus();
+}
 
-	// If the target is defined within package, offer the user
-	// a chance to debug the initializer (there may or may not
-	// be an initializer, we don't really know at this point)
-
-	if( m_targetInfo->getPkgOid() == 0 )
-		chkPkgInit->Disable();
-	else
-		chkPkgInit->Enable();
-
-	// Set the columns' size
-
-	grdParams->SetColSize(COL_NAME, 200);
-	grdParams->SetColSize(COL_TYPE, 100);
-	grdParams->SetColSize(COL_VALUE, 150);
-
-	// If the target function has no parameters (and it's not defined within
-	// a package), there's no good reason to wait for the user to hit the Ok
-	// button before we invoke the target...
+void dlgDirectDbg::LoadLastCellSetting(int row_number, int parameter_index, int index_array_bound, bool isArray )
+{
+	wxString lastValue,valKey;
+	dbgTargetInfo *target = m_controller->GetTargetInfo();
+	long num;
 
-	if((m_targetInfo->getArgInCount() + m_targetInfo->getArgInOutCount() == 0 ) && ( m_targetInfo->getPkgOid() == 0))
+	settings->Read(wxT("Debugger/Proc/OID"), &num, -1L);
+	if(num != target->GetOid())
 	{
-		grdParams->AppendRows( 1 );
-		grdParams->SetReadOnly( i, COL_NAME,  true );
-		grdParams->SetReadOnly( i, COL_TYPE,  true );
-		grdParams->SetReadOnly( i, COL_VALUE, true );
-
-		grdParams->SetCellValue( 0, COL_NAME, _( "No arguments required" ));
-		wxFont font = grdParams->GetCellFont( 0, COL_NAME );
-		font.SetStyle( wxFONTSTYLE_ITALIC );
-		grdParams->SetCellFont( 0, COL_NAME, font );
-
-		activateDebugger();
+		return;
 	}
+
 	else
 	{
-		this->ShowModal();
-	}
-}
+	
+		if(!isArray)
+		{
+			valKey = wxString::Format(wxT("Debugger/Proc/%d/0/"), parameter_index); // Non array elements cell index is 0.
+			settings->Read(valKey + wxT("VAL"), &lastValue, wxEmptyString);
+			grdParams->SetCellValue(row_number, COL_VALUE, lastValue);
+		}
 
-////////////////////////////////////////////////////////////////////////////////
-// OnOk()
-//
-//    This event handler is called when the user clicks the OK button - we call the
-//  activateDebugger() function to set the required breakpoint and invoke the
-//  target (after nabbing any parameter values from the prompt dialog)
+		else
+		{
+			long arrCnt;
+
+			settings->Read(wxString::Format(wxT("Debugger/Proc/%d/"), parameter_index) + wxT("ArrCnt"), &arrCnt, 0L);
+
+			for( int i=0; i <=index_array_bound && i <= arrCnt-1; i++ ) // Refresh an entire array element 
+			{
+				valKey = wxString::Format(wxT("Debugger/Proc/%d/%d/"), parameter_index , i);
+				settings->Read(valKey + wxT("VAL"), &lastValue, wxEmptyString);
+				grdParams->SetCellValue((row_number-index_array_bound) + i, COL_VALUE, lastValue);
+			}
+		}
+	}
 
-void dlgDirectDbg::OnOk( wxCommandEvent &event )
-{
-	activateDebugger();
 }
 
 ////////////////////////////////////////////////////////////////////////////////
-// loadSettings()
+// LoadSettings()
 //
 //    Loads default values from our .ini file. We save the OID of the most
 //    recent direct-debugging target when close a session. If we're direct-
 //    debugging the same target this time around, we load the argument values
 //    from the .ini file.
-
-void dlgDirectDbg::loadSettings()
+void dlgDirectDbg::LoadSettings()
 {
-	long        lastOID;
+	long     num, arrCnt;
+	wxString tmp, key;
+	bool     initPkgCon = false;
 
-	settings->Read( wxT( "Debugger/Proc/OID" ), &lastOID, -1 );
+	settings->Read(wxT("Debugger/Proc/OID"), &num, -1L);
 
-	if( lastOID == m_targetInfo->getOid())
+	dbgTargetInfo *target = m_controller->GetTargetInfo();
+	pgDbgArgs *args = m_controller->GetTargetInfo()->GetArgs();
+
+	if (num != target->GetOid())
 	{
-		int    count = 0;
+		chkPkgInit->SetValue(target->GetPkgInitOid() != 0L);
+		chkPkgInit->Enable(target->GetPkgInitOid() != 0L);
 
-		for( int i = 0; i < m_targetInfo->getArgCount(); ++i )
+		return;
+	}
+	else
+	{
+		settings->Read(wxT("Debugger/Proc/initialize_package_constructor"), &initPkgCon, true);
+
+		chkPkgInit->SetValue(&initPkgCon && target->GetPkgInitOid() != 0L);
+		chkPkgInit->Enable(target->GetPkgInitOid() != 0L);
+	}
+
+	settings->Read(wxT("Debugger/Proc/args"), &num, 0L);
+
+	if (num <= 0L)
+		return;
+
+	if (!args)
+		return;
+
+	for (int cnt = 0, row = 0; cnt < num && cnt < args->Count();)
+	{
+		ctlGridCellBoolEditor *editor =
+		    dynamic_cast<ctlGridCellBoolEditor *>(
+		        grdParams->GetCellEditor(row, COL_NULL));
+		dbgArgInfo *arg
+		= editor != NULL ? editor->GetArg() : NULL;
+
+		if (arg == NULL)
+		{
+			row++;
+
+			continue;
+		}
+
+		key = wxString::Format(wxT("Debugger/Proc/%d/"), cnt);
+
+		// Use NULL?
+		settings->Read(key + wxT("NULL"), &tmp, wxEmptyString);
+		grdParams->SetCellValue(row, COL_NULL, tmp);
+
+		// Use Default (if available)
+		settings->Read(key + wxT("USE_DEF"), &tmp, wxEmptyString);
+		grdParams->SetCellValue(row, COL_USE_DEF, tmp);
+
+		// Is Array/VARIADIC?
+		settings->Read(key + wxT("ArrCnt"), &arrCnt, 0L);
+
+		if (arrCnt > 0L)
 		{
-			wsArgInfo &arg = (*m_targetInfo)[i];
+			// An individual variable can be an expression or can be the 'NULL' value
+			wxString valKey, strVal, strExpr, strNull;
 
-			if( arg.getMode() != wxT( "o" ))
+			for (int idx = 0; idx < arrCnt; idx++, row++)
 			{
-				settings->Read( wxString::Format( wxT( "Debugger/Proc/argValue%d" ), ++count ), &(arg.getValue()), wxT( "" ));
+				valKey = wxString::Format(wxT("Debugger/Proc/%d/%d/"), cnt, idx);
+
+				// Use 'NULL'?
+				settings->Read(valKey + wxT("NULL"), &strNull, wxEmptyString);
+
+				// Use EXPR?
+				settings->Read(valKey + wxT("EXPR"), &strExpr, wxEmptyString);
+
+				// Value
+				settings->Read(valKey + wxT("VAL"), &strVal, wxEmptyString);
+
+				if (arg->IsArray())
+				{
+					int arrRow = row + 1;
+
+					if (idx == 0)
+					{
+						grdParams->SetReadOnly(row, COL_EXPR, true);
+						grdParams->SetReadOnly(row, COL_VALUE, true);
+
+						grdParams->SetCellBackgroundColour(row, COL_EXPR,  wxColour(235, 235, 235, 90));
+						grdParams->SetCellBackgroundColour(row, COL_VALUE, wxColour(235, 235, 235, 90));
+
+						grdParams->SetRowLabelValue(
+						    row, wxString::Format(wxT("%d"), cnt + 1));
+					}
+					grdParams->InsertRows(arrRow, 1, false);
+					grdParams->SetRowLabelValue(arrRow, wxT("-"));
+
+					grdParams->SetCellValue(arrRow, COL_TYPE, arg->GetBaseType());
+
+					// Is the value an expression?
+					grdParams->SetCellEditor(arrRow, COL_EXPR, new ctlGridCellBoolEditor());
+					grdParams->SetCellRenderer(arrRow, COL_EXPR,
+					                           new wxGridCellBoolRenderer());
+					grdParams->SetCellValue(arrRow, COL_EXPR, strExpr);
+
+					// Set value to NULL?
+					grdParams->SetCellEditor(arrRow, COL_NULL,
+					                         new ctlGridCellBoolEditor(arg));
+					grdParams->SetCellRenderer(arrRow, COL_NULL,
+					                           new wxGridCellBoolRenderer());
+					grdParams->SetCellValue(arrRow, COL_NULL, strNull);
+
+					// Set value
+					grdParams->SetCellValue(arrRow, COL_VALUE, strVal);
+
+					grdParams->SetReadOnly(arrRow, COL_NULL, false);
+					grdParams->SetReadOnly(arrRow, COL_EXPR, false);
+					grdParams->SetReadOnly(arrRow, COL_VALUE, false);
+
+					grdParams->SetCellBackgroundColour(arrRow, COL_NAME,    wxColour(235, 235, 235, 90));
+					grdParams->SetCellBackgroundColour(arrRow, COL_TYPE,    wxColour(235, 235, 235, 90));
+					grdParams->SetCellBackgroundColour(arrRow, COL_USE_DEF, wxColour(235, 235, 235, 90));
+					grdParams->SetCellBackgroundColour(arrRow, COL_DEF_VAL, wxColour(235, 235, 235, 90));
+
+					grdParams->SetReadOnly(arrRow + 1, COL_NAME,    true);
+					grdParams->SetReadOnly(arrRow + 1, COL_TYPE,    true);
+					grdParams->SetReadOnly(arrRow + 1, COL_NULL,    true);
+					grdParams->SetReadOnly(arrRow + 1, COL_EXPR,    true);
+					grdParams->SetReadOnly(arrRow + 1, COL_VALUE,   true);
+					grdParams->SetReadOnly(arrRow + 1, COL_USE_DEF, true);
+					grdParams->SetReadOnly(arrRow + 1, COL_DEF_VAL, true);
+
+					grdParams->SetCellBackgroundColour(arrRow + 1, COL_NAME, wxColour(235, 235, 235, 90));
+					grdParams->SetCellBackgroundColour(arrRow + 1, COL_TYPE, wxColour(235, 235, 235, 90));
+					grdParams->SetCellBackgroundColour(arrRow + 1, COL_NULL, wxColour(235, 235, 235, 90));
+					grdParams->SetCellBackgroundColour(arrRow + 1, COL_EXPR, wxColour(235, 235, 235, 90));
+					grdParams->SetCellBackgroundColour(arrRow + 1, COL_VALUE, wxColour(235, 235, 235, 90));
+					grdParams->SetCellBackgroundColour(arrRow + 1, COL_USE_DEF,
+					                                   wxColour(235, 235, 235, 90));
+					grdParams->SetCellBackgroundColour(arrRow + 1, COL_DEF_VAL,
+					                                   wxColour(235, 235, 235, 90));
+
+					grdParams->SetRowLabelValue(arrRow + 1, wxT("+"));
+				}
+				else
+				{
+					grdParams->SetCellValue(row, COL_VALUE, strVal);
+					grdParams->SetCellValue(row, COL_EXPR, strExpr);
+					grdParams->SetCellValue(row, COL_NULL, strNull);
+
+					grdParams->SetReadOnly(row, COL_NULL, false);
+					grdParams->SetReadOnly(row, COL_EXPR, false);
+					grdParams->SetReadOnly(row, COL_VALUE, false);
+
+					grdParams->SetRowLabelValue(
+					    row, wxString::Format(wxT("%d"), cnt + 1));
+				}
 			}
+			if (arg->IsArray())
+				row++;
 		}
+		cnt++;
 	}
 }
 
-////////////////////////////////////////////////////////////////////////////////
-// saveSettings()
-//
-//    Save default values to our .ini file. We save the OID of the most
-//    recent direct-debugging target when close a session. We also save the
-//  value of each argument - if you debug the same target again next time,
-//    loadSettings() will initialize the parameter-values window with the
-//    same parameter values that you entered in this session.
 
-void dlgDirectDbg::saveSettings()
+void dlgDirectDbg::OnOk(wxCommandEvent &_ev)
 {
-	settings->WriteLong( wxT( "Debugger/Proc/OID" ), m_targetInfo->getOid());
+	if (m_thread)
+		return;
+
+	grdParams->Enable(false);
+	btnDebug->Enable(false);
 
-	int    count = 0;
+	m_thread = new dbgArgValueEvaluator(m_conn, this);
 
-	for( int i = 0; i < m_targetInfo->getArgCount(); ++i )
+	if (m_thread->Create() != wxTHREAD_NO_ERROR)
 	{
-		wsArgInfo &arg = ( *m_targetInfo)[i];
+		delete m_thread;
+		m_thread = NULL;
 
-		if( arg.getMode() != wxT( "o" ))
-		{
-			settings->Write( wxString::Format( wxT( "Debugger/Proc/argName%d" ), ++count ), arg.getName());
-			settings->Write( wxString::Format( wxT( "Debugger/Proc/argType%d" ),   count ), arg.getType());
-			settings->Write( wxString::Format( wxT( "Debugger/Proc/argValue%d" ),  count ), wxString((arg.getValue() == wxT("NULL") ? wxEmptyString : arg.getValue().c_str())));
-		}
+		wxLogError(_("Couldn't create the required thread for this."));
+		EndModal(wxID_CANCEL);
+
+		return;
 	}
+
+	m_thread->Run();
 }
 
-////////////////////////////////////////////////////////////////////////////////
-// OnCancel()
-//
-//    This event handler is called when the user clicks the Cancel button - we
-//    close the connection to the server and then close ourself.
 
-void dlgDirectDbg::OnCancel( wxCommandEvent &event )
+void dlgDirectDbg::OnCancel(wxCommandEvent &_ev)
 {
-	// This will raise close event which is handled by
-	// dlgDirectDbg::OnClose().
-	m_cancelled = true;
-	Close();
-}
+	if (m_thread)
+	{
+		m_thread->CancelEval();
 
-////////////////////////////////////////////////////////////////////////////////
-// OnClose()
-//
-//    wxWidgets invokes this event handler when the user closes the parameter
-//    window. We close the connection with server and raise close event for
-//    MainFrame.
+		m_thread->Wait();
 
-void dlgDirectDbg::OnClose( wxCloseEvent &event )
+		delete m_thread;
+		m_thread = NULL;
+	}
+	_ev.Skip();
+}
+
+void dlgDirectDbg::OnClickGridLabel(wxGridEvent &_ev)
 {
-	// Destroy the grid - required as it seems to create threads in some cases
-	if (grdParams)
+	if (_ev.AltDown() || _ev.ControlDown() || _ev.ShiftDown())
 	{
-		grdParams->Destroy();
-		delete grdParams;
+		_ev.Skip();
+
+		return;
 	}
 
-	// Close the debugger (proxy) connection
-	if (m_conn)
+	int row = _ev.GetRow();
+	int col = _ev.GetCol();
+
+	if (row < 0 || col > 0)
 	{
-		m_conn->Close();
-		delete m_conn;
-		m_conn = NULL;
+		_ev.Skip();
+
+		return;
 	}
 
-	// Closing frmMain from here leads to recursive call
-	// to OnClose function on windows
-#ifndef __WXWIN__
-	// This will inform the MainWindow to close.
-	// if it's not visible yet.
-	if (m_parent->IsShown())
-		event.Skip();
+	wxString strLabel = grdParams->GetRowLabelValue(row);
+
+	if (strLabel == wxT("+"))
+	{
+		wxASSERT(row != 0);
+
+		ctlGridCellBoolEditor *editor =
+		    dynamic_cast<ctlGridCellBoolEditor *>(
+		        grdParams->GetCellEditor(row - 1, COL_NULL));
+		dbgArgInfo *arg
+		= editor != NULL ? editor->GetArg() : NULL;
+
+		grdParams->InsertRows(row, 1, false);
+		grdParams->SetRowLabelValue(row, wxT("-"));
+
+		grdParams->SetCellValue(row, COL_TYPE, arg->GetBaseType());
+		grdParams->SetCellBackgroundColour(row, COL_TYPE, wxColour(235, 235, 235, 90));
+		grdParams->SetCellBackgroundColour(row, COL_NAME, wxColour(235, 235, 235, 90));
+		grdParams->SetCellBackgroundColour(row, COL_USE_DEF, wxColour(235, 235, 235, 90));
+		grdParams->SetCellBackgroundColour(row, COL_DEF_VAL, wxColour(235, 235, 235, 90));
+
+		// Is the value an expression?
+		grdParams->SetCellEditor(row, COL_EXPR, new ctlGridCellBoolEditor());
+		grdParams->SetCellRenderer(row, COL_EXPR, new wxGridCellBoolRenderer());
+		grdParams->SetCellValue(row, COL_EXPR, wxT(""));
+
+		// Set value to NULL?
+		grdParams->SetCellEditor(row, COL_NULL, new ctlGridCellBoolEditor(arg));
+		grdParams->SetCellRenderer(row, COL_NULL, new wxGridCellBoolRenderer());
+		grdParams->SetCellValue(row, COL_NULL, wxT("1"));
+
+		row++;
+		grdParams->SetRowLabelValue(row, wxT("+"));
+	}
+	else if (strLabel == wxT("-"))
+	{
+		dbgArgInfo *arg = NULL;
+		grdParams->DeleteRows(row, 1, false);
+	}
 	else
-		m_parent->Close();
-#endif // __WXWIN__
+		return;
+
+	// Update the row labels
+	ctlGridCellBoolEditor *editor = NULL;
+	dbgArgInfo *arg = NULL,
+	            *prev = NULL;
+	wxString strName;
+
+	int totalRows = grdParams->GetNumberRows(),
+	    idx = 0;
+	row = 0;
 
-	if ( this->IsModal() )
+	while (row < totalRows)
 	{
-		if ( m_cancelled )
-			EndModal( wxID_CANCEL );
+		editor =
+		    dynamic_cast<ctlGridCellBoolEditor *>(
+		        grdParams->GetCellEditor(row, COL_NULL));
+		arg	= editor != NULL ? editor->GetArg() : NULL;
+		strName = grdParams->GetCellValue(row, COL_NAME);
+
+		if (strName.IsEmpty() && arg)
+			grdParams->SetRowLabelValue(row, wxT("-"));
+		else if (!strName.IsEmpty() && !arg)
+			grdParams->SetRowLabelValue(row, wxT("+"));
 		else
-			EndModal( wxID_OK);
+		{
+			idx++;
+			grdParams->SetRowLabelValue(row, wxString::Format(wxT("%d"), idx));
+		}
+
+		row++;
 	}
 }
 
 ////////////////////////////////////////////////////////////////////////////////
-// activateDebugger()
+// SaveSettings()
 //
-//    This function is called after the user has filled in any parameter values
-//  and clicked the Ok button.  activateDebugger() extracts the paramter values
-//  from the grid control and copies those values into our dbgTargetInfo object
-//  (m_targetInfo).  Next, we set a breakpoint at the target, and, finally,
-//  we invoke the target function/procedure
-
-bool dlgDirectDbg::activateDebugger( )
+//    Save default values to our .ini file. We save the OID of the most
+//    recent direct-debugging target when close a session. We also save the
+//    value of each argument - if you debug the same target again next time,
+//    loadSettings() will initialize the parameter-values window with the
+//    same parameter values that you entered in this session.
+//
+void dlgDirectDbg::SaveSettings()
 {
-	// Unset the completed flag (if it exists)
-	if (m_codeWindow)
-		m_codeWindow->m_targetComplete = false;
-
-	// Copy the parameter values from the grid into m_targetInfo
-	int i = 0;
-
-	for( int count = 0; count < m_targetInfo->getArgCount(); ++count )
+	wxString    strName, strExpr, strVal, strNull, strDef, strKey, strValExpr;
+	dbgArgInfo *prev = NULL,
+	            *arg = NULL;
+	int         row = 0,
+	            idx = -1,
+	            arrCnt = 1;
+
+	// Save the current function/procedure/trigger OID
+	settings->WriteLong(wxT("Debugger/Proc/OID"),
+	                    m_controller->GetTargetInfo()->GetOid());
+
+	// Save - whether we need to debug the package constructor
+	settings->WriteBool(wxT("Debugger/Proc/initialize_package_constructor"),
+	                    (chkPkgInit->IsEnabled() && chkPkgInit->GetValue()));
+
+	for (; row < grdParams->GetNumberRows(); row++)
 	{
-		wsArgInfo &arg = (*m_targetInfo)[count];
+		ctlGridCellBoolEditor *editor =
+		    dynamic_cast<ctlGridCellBoolEditor *>(
+		        grdParams->GetCellEditor(row, COL_NULL));
+		arg	= editor != NULL ? editor->GetArg() : NULL;
 
-		// Populate the ArgInfo object's IN or INOUT variables only, OUT
-		// variables will be assigned NULL later on.
+		// This should be the information for add/remove values for an array
+		if (arg == NULL)
+		{
+			continue;
+		}
+		else if (prev != arg)
+		{
+			idx++;
+			prev = arg;
 
-		if(arg.getMode() != wxT("o"))
+			if (arg->IsArray())
+			{
+				arrCnt = 0;
+			}
+			else
+			{
+				arrCnt = 1;
+			}
+		}
+		else
 		{
-			arg.setValue( grdParams->GetCellValue(i, COL_VALUE));
-			i++;
+			arrCnt++;
 		}
-	}
 
-	// Write the target OID and argument values to our settings file
-	// so that we can default them next time around
-	saveSettings();
+		settings->WriteInt(wxString::Format(wxT("Debugger/Proc/%d/ArrCnt"), idx), arrCnt);
 
-	// Now set a breakpoint at the target (note: the call to setBreakpoint()
-	// will hang until the  server sends us a response)
+		if ((arrCnt == 0 && arg->IsArray()) ||
+		        (arrCnt == 1 && !arg->IsArray()))
+		{
+			// Use Default (if available)
+			settings->Write(wxString::Format(wxT("Debugger/Proc/%d/USE_DEF"), idx),
+			                grdParams->GetCellValue(row, COL_USE_DEF));
 
-	try
-	{
-		// Debug the initialiser. We can only do so once, so unset, and disable
-		// the option after setting the breakpoint
-		if( chkPkgInit->GetValue())
-			setBreakpoint( m_targetInfo->getPkgOid(), m_targetInfo->getPkgInitOid());
+			// Use NULL?
+			settings->Write(wxString::Format(wxT("Debugger/Proc/%d/NULL"), idx),
+			                grdParams->GetCellValue(row, COL_NULL));
 
-		chkPkgInit->SetValue(false);
-		chkPkgInit->Disable();
+			if (arrCnt == 0 && arg->IsArray())
+				continue;
+		}
 
-		setBreakpoint( m_targetInfo->getPkgOid(), m_targetInfo->getOid());
-	}
-	catch( const std::runtime_error &error )
-	{
-		wxMessageBox( wxString( error.what(), wxConvUTF8 ), _( "Cannot create breakpoint" ), wxOK | wxICON_ERROR );
-		return( false );
-	}
+		strKey = wxString::Format(wxT("Debugger/Proc/%d/%d/"), idx, arrCnt - 1);
 
-	// And invoke the target (note: the call to invokeTarget() will *NOT*
-	// wait for a result set from the server - instead, OnResultReady() will
-	// be called when the result set is ready)
+		// Use NULL?
+		settings->Write(strKey + wxT("NULL"),
+		                grdParams->GetCellValue(row, COL_NULL));
 
-	try
-	{
-		invokeTarget();
-	}
-	catch( const std::runtime_error &error )
-	{
-		wxMessageBox( wxString( error.what(), wxConvUTF8 ), _( "Cannot invoke target" ), wxOK | wxICON_ERROR );
-		return( false );
+		// Is value EXPR?
+		settings->Write(strKey + wxT("EXPR"),
+		                grdParams->GetCellValue(row, COL_EXPR));
+
+		// Value
+		settings->Write(strKey + wxT("VAL"),
+		                grdParams->GetCellValue(row, COL_VALUE));
 	}
 
-	return( true );
+	// Save the number of arguments
+	settings->WriteLong(wxT("Debugger/Proc/args"), (long)(idx + 1));
 }
 
-////////////////////////////////////////////////////////////////////////////////
-// setBreakpoint()
-//
-//    This function creates a breakpoint at the target.  For now, we always create
-//  a breakpoint by calling edb_procoid_debug() or plpgsql_procoid_debug() with
-//  the OID of the target.  Later, we'll change this function to use the
-//  new CREATE BREAKPOINT command.
 
-void dlgDirectDbg::setBreakpoint(long pkgOid, long funcOid)
+ctlGridCellBoolEditor::ctlGridCellBoolEditor(dbgArgInfo *_arg)
+	: m_arg(_arg)
+{}
+
+
+void ctlGridCellBoolEditor::BeginEdit(int _row, int _col, wxGrid *_grid)
 {
-	dbgResultset *result;
+	wxGridCellBoolEditor::BeginEdit(_row, _col, _grid);
 
-	if (m_conn->DebuggerApiVersion() <= DEBUGGER_V2_API)
-	{
-		if( m_targetInfo->getLanguage() == wxT( "edbspl" ))
-			result = new dbgResultset(m_conn->waitForCommand(wxString::Format(wxT("select edb_oid_debug( %ld, %ld );"), pkgOid, funcOid)));
-		else
-			result = new dbgResultset(m_conn->waitForCommand(wxString::Format(wxT("select plpgsql_oid_debug( %ld, %ld );"),  pkgOid, funcOid)));
-	}
-	else
+	wxFocusEvent event (wxEVT_KILL_FOCUS);
+	if (m_control)
 	{
-		if( m_targetInfo->getLanguage() == wxT( "edbspl" ))
-			result = new dbgResultset(m_conn->waitForCommand(wxString::Format(wxT("select edb_oid_debug(%ld);"), funcOid)));
-		else
-			result = new dbgResultset(m_conn->waitForCommand(wxString::Format(wxT("select plpgsql_oid_debug(%ld);"), funcOid)));
+		m_control->GetEventHandler()->AddPendingEvent(event);
 	}
-
-	if( result->getCommandStatus() != PGRES_TUPLES_OK )
-		throw( std::runtime_error( result->getRawErrorMessage()));
 }
 
-////////////////////////////////////////////////////////////////////////////////
-// invokeTarget()
-//
-//    This function invokes the debugger target (that is, the function or procedure
-//  that the user wants to debug).  If the target is a function, we generate a
-//  SELECT statement; if the target is a procedure, we generate an EXEC statement.
-//  In either case, we build the argument list from the argument values found
-//  in m_targetInfo
 
-void dlgDirectDbg::invokeTarget()
+wxGrid *dlgDirectDbg::GetParamsGrid()
 {
-	// If we have access the the EDB extended libpq functions,
-	// and this is a stored procedure, we should execute the
-	// procedure using the callable statement interface to allow
-	// us to retrieve the OUT/INOUT parameter results.
-	// Otherwise, just SELECT/EXEC it as per normal.
-#ifdef __WXMSW__
-	if (!m_conn->EdbMinimumVersion(9, 0) &&
-	        !m_targetInfo->getIsFunction() &&
-	        PQiGetOutResult &&
-	        PQiPrepareOut &&
-	        PQiSendQueryPreparedOut)
-		invokeTargetCallable();
-	else
-#else
-#ifdef EDB_LIBPQ
-	if (!m_conn->EdbMinimumVersion(9, 0) &&
-	        !m_targetInfo->getIsFunction())
-		invokeTargetCallable();
-	else
-#endif
-#endif
-		invokeTargetStatement();
-
-	// Since parameter window has done its job, we need to hide
-	// it and let code window come in front.
-	if (m_codeWindow)
-	{
-		m_codeWindow->enableTools();
-		m_codeWindow->resumeLocalDebugging();
-	}
+	return grdParams;
+}
 
-	this->Show( false );
+bool dlgDirectDbg::DebugPkgConstructor()
+{
+	return chkPkgInit->IsEnabled() && chkPkgInit->GetValue();
 }
 
-void dlgDirectDbg::invokeTargetCallable()
+
+wxGridCellEditor *ctlGridCellBoolEditor::Clone() const
 {
-	dbgPgParams *params = new dbgPgParams();
+	return new ctlGridCellBoolEditor(m_arg);
+}
 
-	wxString query = wxT("CALL ") + m_targetInfo->getFQName() + wxT("(");
 
-	// Setup the param struct.
-	params->nParams = m_targetInfo->getArgCount();
-	params->paramTypes = new Oid[params->nParams];
-	params->paramValues = new char*[params->nParams];
-	params->paramModes = new int[params->nParams];
+void dlgDirectDbg::ResultArgsUpdated(wxCommandEvent &_ev)
+{
+	SaveSettings();
+	SavePosition();
 
-	// Iterate through the parameters, adding them to the param
-	// struct and the statement as we go.
-	for( int i = 0; i < params->nParams; ++i )
+	if (m_thread)
 	{
-		wsArgInfo &arg = (*m_targetInfo)[i];
+		m_thread->CancelEval();
+		m_thread->Wait();
 
-		params->paramTypes[i] = arg.getTypeOid();
+		delete m_thread;
+		m_thread = NULL;
+	}
 
-		if(arg.getMode() == wxT("o")) // OUT
-		{
-			params->paramModes[i] = 2;
-			params->paramValues[i] = 0;
-		}
-		else if(arg.getMode() == wxT("b")) // IN OUT
-		{
-			params->paramModes[i] = 3;
-
-			int len = arg.getValue().Length() + 1;
-			char *tmp = new char[len];
-			snprintf(tmp, len, "%s", (const char *)arg.getValue().mb_str(wxConvUTF8));
-			if (strcmp(tmp, "") == 0)
-				params->paramValues[i] = 0;
-			else if (strcmp(tmp, "''") == 0)
-				params->paramValues[i] = (char *)"";
-			else if (strcmp(tmp, "\\'\\'") == 0)
-				params->paramValues[i] = (char *)"''";
-			else
-				params->paramValues[i] = tmp;
-		}
-		else // IN
+	if (IsModal())
+		EndModal(wxID_OK);
+	else
+		Destroy();
+}
+
+
+void dlgDirectDbg::ResultArgsUpdateError(wxCommandEvent &_ev)
+{
+	if (_ev.GetInt() == pgQueryResultEvent::PGQ_CONN_LOST)
+	{
+		if(wxMessageBox(
+		            _("Connection to the database server lost!\nDo you want to try to reconnect to the server?"),
+		            _("Connection Lost"), wxICON_ERROR | wxICON_QUESTION | wxYES_NO) == wxID_YES)
 		{
-			params->paramModes[i] = 1;
-
-			int len = arg.getValue().Length() + 1;
-			char *tmp = new char[len];
-			snprintf(tmp, len, "%s", (const char *)arg.getValue().mb_str(wxConvUTF8));
-			if (strcmp(tmp, "") == 0)
-				params->paramValues[i] = 0;
-			else if (strcmp(tmp, "''") == 0)
-				params->paramValues[i] = (char *)"";
-			else if (strcmp(tmp, "\\'\\'") == 0)
-				params->paramValues[i] = (char *)"''";
-			else
-				params->paramValues[i] = tmp;
+			if (m_thread)
+			{
+				m_thread->CancelEval();
+
+				m_thread->Wait();
+
+				delete m_thread;
+				m_thread = NULL;
+			}
+			m_conn->Reconnect();
+
+			return;
 		}
+		EndModal(wxID_CANCEL);
 
-		if (i)
-			query += wxT(", ");
-		query += wxString::Format(wxT("$%d::"), i + 1) + arg.getType();
+		return;
+	}
 
+	if (m_thread)
+	{
+		m_thread->CancelEval();
+		m_thread->Wait();
+
+		delete m_thread;
+		m_thread = NULL;
 	}
 
-	query += wxT(");");
+	wxLogError(_ev.GetString());
 
-	// And send the completed command to the server - we'll get
-	// a dbgDbResult event when the command completes (and that
-	// event will get routed to dlgDirectDbg::OnResultReady())
-	m_conn->startCommand( query, GetEventHandler(), RESULT_ID_DIRECT_TARGET_COMPLETE, params );
+	grdParams->Enable(true);
+	btnDebug->Enable(true);
 }
 
-void dlgDirectDbg::invokeTargetStatement()
+
+void dbgArgValueEvaluator::NoticeHandler(void *, const char *)
 {
-	wxString query, declareStatement;
-	if (!m_conn->EdbMinimumVersion(8, 4))
-		query = m_targetInfo->getIsFunction() ? wxT( "SELECT " ) : wxT( "EXEC " );
-	else
-	{
-		query = wxT("SELECT");
-		if (!m_targetInfo->getIsFunction())
-			query = wxT("EXEC ");
-		else if (m_targetInfo->getLanguage() == wxT("edbspl"))
-			query = wxT("PERFORM ");
-	}
+	// Ignore the notices
+}
+
+
+void *dbgArgValueEvaluator::Entry()
+{
+	bool argNull, nullVal, useDef;
+	wxString strVal, strValExpr;
+	dbgArgInfo *prev = NULL,
+	            *arg = NULL;
 
-	// If this is a function, and the return type is not record, or
-	// we have at least one OUT/INOUT param, we should select from
-	// the function to get a full resultset.
-	if (m_targetInfo->getIsFunction() && m_targetInfo->getLanguage() != wxT("edbspl") &&
-	        (m_targetInfo->getReturnType() != wxT("record") ||
-	         m_targetInfo->getArgInOutCount() > 0 ||
-	         m_targetInfo->getArgOutCount() > 0))
-		query.Append(wxT("* FROM "));
+	wxGrid *grd = m_dlg->GetParamsGrid();
 
-	// Stuff the verb (SELECT or EXEC), schema, and target name into the query
-	query.Append(m_targetInfo->getFQName());
+	m_dlg->m_controller->GetTargetInfo()->DebugPackageConstructor()
+	= m_dlg->DebugPkgConstructor();
 
-	// Now append the argument list
-	query.Append(wxT("("));
+	m_conn->RegisterNoticeProcessor(dbgArgValueEvaluator::NoticeHandler, NULL);
 
-	for(int i = 0; i < m_targetInfo->getArgCount(); ++i)
+	for (int row = 0, idx = 0, arrCnt = 1, arr_idx_bound = 0;
+	        row < grd->GetNumberRows() && !m_cancelled; row++)
 	{
-		wsArgInfo &arg = (*m_targetInfo)[i];
+		ctlGridCellBoolEditor *editor =
+		    dynamic_cast<ctlGridCellBoolEditor *>(
+		        grd->GetCellEditor(row, dlgDirectDbg::COL_NULL));
+		arg	= editor != NULL ? editor->GetArg() : NULL;
 
-		if(arg.getMode() == wxT("o") && !m_conn->EdbMinimumVersion(8, 4))
-		{
-			if (!m_targetInfo->getIsFunction() || m_targetInfo->getLanguage() == wxT("edbspl"))
-				query.Append( wxT("NULL::") + arg.getType() + wxT(", "));
-		}
-		else if (m_conn->EdbMinimumVersion(8, 4) && (arg.getMode() == wxT("o") || arg.getMode() == wxT("b")))
+		// This should be the information for add/remove values for an array
+		if (arg == NULL)
 		{
-			if (!m_targetInfo->getIsFunction() || m_targetInfo->getLanguage() == wxT("edbspl"))
+			// prev was an array, can we fetch value for the same
+			if (prev && !prev->Null())
 			{
-				wxString strParam = wxString::Format(wxT("param%d"), i);
-				declareStatement +=  strParam + wxT(" ") + arg.getType();
-				if (arg.getMode() == wxT("b"))
+				wxString res =
+				    m_conn->ExecuteScalar(
+				        wxT("SELECT ARRAY[") + strValExpr + wxT("]::") + prev->GetTypeName(),
+				        false);
+
+				if (m_cancelled)
 				{
-					declareStatement += wxT(" := ") + arg.quoteValue();
-					if (!arg.quoteValue().Contains(wxT("::")))
-						declareStatement += wxT("::") + arg.getType();
+					m_conn->RegisterNoticeProcessor(NULL, NULL);
+
+					return (void *)NULL;
 				}
-				declareStatement += wxT(";\n");
-				query.Append(strParam + wxT(", "));
-			}
-			else if (arg.getMode() != wxT("o"))
-			{
-				if (!arg.quoteValue().Contains(wxT("::")))
-					query.Append( arg.quoteValue() + wxT("::") + arg.getType() + wxT(", "));
-				else
-					query.Append( arg.quoteValue() + wxT(", "));
-			}
-		}
-		else if(arg.getMode() == wxT("v"))
-			query.Append( arg.getValue() + wxT(", "));
-		else
-		{
-			if (!arg.quoteValue().Contains(wxT("::")))
-				query.Append( arg.quoteValue() + wxT("::") + arg.getType() + wxT(", "));
-			else
-				query.Append( arg.quoteValue() + wxT(", "));
-		}
-	}
+				if (m_conn->GetStatus() == PGCONN_BAD)
+				{
+					wxCommandEvent ev(wxEVT_COMMAND_MENU_SELECTED, RESULT_ID_ARGS_UPDATE_ERROR);
 
-	if (query.EndsWith(wxT(", ")))
-		query = query.Left(query.Length() - 2);
-	else if (query.EndsWith(wxT("(")))
-		query = query.Left(query.Length() - 1);
+					ev.SetInt(pgQueryResultEvent::PGQ_CONN_LOST);
 
-	// And terminate the argument list
-	if(m_targetInfo->getArgInCount() + m_targetInfo->getArgInOutCount() == 0)
-	{
-		/*
-		 * edbspl function/procedure with OUT parameter takes value/variable as an input
-		 */
-		if (m_conn->GetIsEdb())
-		{
-			if (m_targetInfo->getArgCount() == 0)
-			{
-				if (m_targetInfo->getIsFunction() || m_targetInfo->getLanguage() != wxT("edbspl"))
-					query.Append(wxT("()"));
-			}
-			else if (m_targetInfo->getLanguage() != wxT("edbspl"))
-				query.Append(wxT("()"));
-			else
-				query.Append(wxT(")"));
-		}
-		else if (m_targetInfo->getIsFunction())
-			query.Append(wxT("()"));
-	}
-	else
-	{
-		query.Append(wxT(")"));
-	}
+					m_dlg->GetEventHandler()->AddPendingEvent(ev);
 
-	if (m_conn->EdbMinimumVersion(8, 4) && (m_targetInfo->getLanguage() == wxT("edbspl") || !m_targetInfo->getIsFunction()))
-	{
-		wxString tmpQuery = wxT("DECLARE\n")
-		                    + declareStatement
-		                    + wxT("BEGIN\n")
-		                    + query + wxT(";\n")
-		                    + wxT("END;");
-		query = tmpQuery;
-	}
+					m_conn->RegisterNoticeProcessor(NULL, NULL);
 
-	// And send the completed command to the server - we'll get
-	// a dbgDbResult event when the command completes (and that
-	// event will get routed to dlgDirectDbg::OnResultReady())
-	m_conn->startCommand( query, GetEventHandler(), RESULT_ID_DIRECT_TARGET_COMPLETE );
-}
+					return (void *)NULL;
+				}
+				if (m_conn->GetLastResultStatus() == PGRES_TUPLES_OK)
+				{
+					prev->Value() = res;
+				}
+				else
+				{
+					wxCommandEvent ev(wxEVT_COMMAND_MENU_SELECTED, RESULT_ID_ARGS_UPDATE_ERROR);
+					wxString strName = prev->GetName();
+					wxString strMsg;
+
+					if (strName.IsEmpty())
+					{
+						ev.SetString(
+						    wxString::Format(
+						        _("Specified value for the argument#%d is not valid.\nPlease reenter the value for it."),
+						        idx));
+					}
+					else
+					{
+						ev.SetString(
+						    wxString::Format(
+						        _("Specified value for the argument - '%s' is not valid.\nPlease reenter the value for it."),
+						        strName.c_str()));
+					}
+					ev.SetInt(pgQueryResultEvent::PGQ_RESULT_ERROR);
+					m_dlg->LoadLastCellSetting(row-1, idx-1, arr_idx_bound-1 , true); 
+					m_dlg->GetEventHandler()->AddPendingEvent(ev);
+
+					m_conn->RegisterNoticeProcessor(NULL, NULL);
+
+					return (void *)NULL;
 
+				}
+				prev = NULL;
+				arr_idx_bound = 0;
+			}
 
-////////////////////////////////////////////////////////////////////////////////
-// OnTargetComplete()
-//
-//    This event handler is called when the target function/procedure completes
-//  and a result set (or error) has been returned by the server.  The event
-//  object contains a pointer to the result set.
-//
-//  For now, we display an error message (if an error occurred) or write the
-//  command status to the status bar (if the target completed without error).
-//
-//  We should really display the complete result set somewhere too.
+			continue;
+		}
+		else if (prev != arg)
+		{
+			idx++;
+			argNull = false;
+			nullVal = false;
+			useDef  = false;
 
-void dlgDirectDbg::OnTargetComplete( wxCommandEvent &event )
-{
-	// Extract the result set handle from the event and log the status info
+			strValExpr = wxEmptyString;
+		}
 
-	PGresult    *result = (PGresult *)event.GetClientData();
+		if (prev != arg)
+		{
+			prev = arg;
 
-	wxLogInfo( wxT( "OnTargetComplete() called\n" ));
-	wxLogInfo( wxT( "%s\n" ), wxString(PQresStatus( PQresultStatus( result )), wxConvUTF8).c_str());
+			// Use Default (if available)
+			arg->UseDefault() = wxGridCellBoolEditor::IsTrueValue(
+			                        grd->GetCellValue(row, dlgDirectDbg::COL_USE_DEF));
+			// NULL?
+			arg->Null() = wxGridCellBoolEditor::IsTrueValue(
+			                  grd->GetCellValue(row, dlgDirectDbg::COL_NULL));
 
-	// If the query failed, write the error message to the status line, otherwise, copy the result set into the grid
-	if(( PQresultStatus( result ) == PGRES_NONFATAL_ERROR ) || ( PQresultStatus( result ) == PGRES_FATAL_ERROR ))
-	{
-		wxString    message( PQresultErrorMessage( result ), wxConvUTF8 );
+			if (arg->UseDefault())
+				strValExpr = arg->Default();
 
-		message.Replace( wxT( "\n" ), wxT( " " ));
+			if (arg->IsArray())
+				continue;
+		}
 
-		m_parent->getStatusBar()->SetStatusText( message, 1 );
-		char *state = PQresultErrorField(result, PG_DIAG_SQLSTATE);
+		// Use NULL?
+		//
+		//   Keep this just before 'Use Default' column as - we may have non-empty
+		//   value in the 'VAL' column
 
-		// Don't bother telling the user that he aborted - he already knows!
-		// Depending on the stage, m_conn might not be set all! so check for
-		// that first
-		if (m_conn)
+		if (!arg->UseDefault() || !arg->Null())
 		{
-			if (state != NULL && strcmp(state, "57014"))
-				wxLogError( wxT( "%s\n" ), wxString(PQerrorMessage(m_conn->getConnection()), wxConvUTF8).c_str());
+			if (!strValExpr.IsEmpty())
+			{
+				strValExpr += wxT(", ");
+			}
+
+			if (wxGridCellBoolEditor::IsTrueValue(
+			            grd->GetCellValue(row, dlgDirectDbg::COL_NULL)))
+			{
+				strValExpr += wxT("NULL");
+			}
+			else if (wxGridCellBoolEditor::IsTrueValue(
+			             grd->GetCellValue(row, dlgDirectDbg::COL_EXPR)))
+			{
+				strValExpr += grd->GetCellValue(row, dlgDirectDbg::COL_VALUE);
+			}
 			else
-				wxLogInfo( wxT( "%s\n" ), wxString(PQerrorMessage(m_conn->getConnection()), wxConvUTF8).c_str());
+			{
+				strValExpr += m_conn->qtDbString(
+				                  grd->GetCellValue(row, dlgDirectDbg::COL_VALUE));
+			}
+			
+			strValExpr.Append(wxT("::"))
+			.Append(arg->IsArray() ?
+			        arg->GetBaseType(): arg->GetTypeName());
+			if(arg->IsArray())
+			{
+				arr_idx_bound ++;
+			}
 		}
-	}
-	else
-	{
-		wxString message( PQcmdStatus( result ), wxConvUTF8 );
+		if (!arg->IsArray() && !arg->Null())
+		{
+			pgSet *set =
+			    m_conn->ExecuteSet(wxT("SELECT ") + strValExpr, false);
 
-		message.Replace( wxT( "\r" ), wxT( "" ));
-		message.Replace( wxT( "\n" ), wxT( " " ));
+			if (m_cancelled)
+			{
+				return (void *)NULL;
+			}
+			if (m_conn->GetStatus() == PGCONN_BAD)
+			{
+				wxCommandEvent ev(wxEVT_COMMAND_MENU_SELECTED, RESULT_ID_ARGS_UPDATE_ERROR);
 
-		m_parent->getStatusBar()->SetStatusText( message, 1 );
+				ev.SetString(_("Connection to the database server lost!"));
+				ev.SetInt(pgQueryResultEvent::PGQ_CONN_LOST);
 
-		// If this result set has any columns, add a result grid to the code window so
-		// we can show the results to the user
+				m_dlg->GetEventHandler()->AddPendingEvent(ev);
 
-		if( m_codeWindow && PQnfields( result ))
-		{
-			m_codeWindow->OnResultSet( result );
-		}
-	}
+				m_conn->RegisterNoticeProcessor(NULL, NULL);
 
-	if (m_codeWindow)
-	{
-		m_codeWindow->m_targetComplete = true;
-		m_codeWindow->disableTools( );
-	}
+				if (set)
+					delete set;
 
-	// Do not show if aborted
-	if ( m_codeWindow && m_codeWindow->m_targetAborted )
-		return;
+				return (void *)NULL;
+			}
+			if (m_conn->GetLastResultStatus() == PGRES_TUPLES_OK &&
+			        set && set->NumRows() > 0L)
+			{
+				if (set->IsNull(0))
+				{
+					arg->Null() = true;
+				}
+				else
+				{
+					arg->Null() = false;
+					arg->Value() = set->GetVal(0);
+				}
+			}
+			else
+			{
+				wxString strName = arg->GetName();
 
-	this->Show( true );
-}
+				if (strName.IsEmpty())
+					strName = wxString::Format(_("Param#%d"), idx);
 
-////////////////////////////////////////////////////////////////////////////////
-// OnNoticeReceived()
-//
-//    This event handler is called when a notice is received from the server (in
-//  response to our invoking the target).  For now, we just forward this event
-//  to the debugger window (m_codeWindow) and the notification message is added
-//  to the debugger's message window.
-//
-//  When/if we get around to adding a result set window to this class, we should
-//  also add a message window too and display notice messages here instead of in
-//  the debugger window.
+				wxCommandEvent ev(wxEVT_COMMAND_MENU_SELECTED, RESULT_ID_ARGS_UPDATE_ERROR);
 
-void dlgDirectDbg::OnNoticeReceived( wxCommandEvent &event )
-{
-	if( m_codeWindow )
-		m_codeWindow->OnNoticeReceived( event );
-}
+				ev.SetString(
+				    wxString::Format(_("Please reenter the value for the argument - '%s'."),
+				                     strName.c_str()));
+				
+				ev.SetInt(pgQueryResultEvent::PGQ_RESULT_ERROR);
 
-////////////////////////////////////////////////////////////////////////////////
-// OnDebug()
-//
-//    This event handler is called when a PLDBGBREAK notice is received from the
-//  server.  A quick review:  we've already set a breakpoint at the target and
-//  then we invoked the target (using the parameter values entered by the user).
-//  Now we're waiting for a result set from the target.  Since we set a breakpoint
-//  inside of the target, the server will send us a specially crafted NOTICE
-//  that tells use which port to attach to in order to contact the debugger
-//  server - that's what 'event' contains.
-//
-//  When we get the PLDBGBREAK message (inside of 'event'), we create a new
-//  debugger window by calling glMainFrame->addDebug() and let that window
-//  take over for a while.  When the target finally completes, we'll get a
-//  a dbgDbResult event and handle the result set inside of OnResultReady()
+				m_dlg->GetEventHandler()->AddPendingEvent(ev);
+				// m_dlg->LoadSettings();
+				m_dlg->LoadLastCellSetting(row, idx-1, 0, false); // For scalar variable, always index of array bound is 0.
+				m_conn->RegisterNoticeProcessor(NULL, NULL);
 
-void dlgDirectDbg::OnDebug( wxCommandEvent &event )
-{
-	// This event contains a string of the form:
-	//     /path/debugger -k --database=db --host=host --port=port --user=user &"
-	// We can use that string to launch a separate debugger client.
-	//
-	// The event also contains a pointer to a map that contains keyword=value
-	// pairs for the debugger connection properties.  To get to that map, we
-	// call event.GetClientData().  Once we have the map, we can look for the
-	// debugger connection properties such as "database", "host", "port", ...
+				return (void *)NULL;
 
-	dbgConnProp *debugProps = (dbgConnProp *)event.GetClientData();
+			}
+		}
+	}
 
-	m_codeWindow = m_parent->addDebug( *debugProps );
+	wxCommandEvent ev(wxEVT_COMMAND_MENU_SELECTED, RESULT_ID_ARGS_UPDATED);
+	m_dlg->GetEventHandler()->AddPendingEvent(ev);
 
-	if (m_codeWindow)
-		m_codeWindow->startLocalDebugging();
+	m_conn->RegisterNoticeProcessor(NULL, NULL);
 
-	this->Show( false );
+	return (void *)NULL;
 }
 
-////////////////////////////////////////////////////////////////////////////////
-// getBreakpointList()
-//
-//    This function returns a non-const reference to our breakpoint list.  The
-//  caller typically populates this list before calling startDebugging() - we
-//  set a breakpoint for each member of the list
 
-dbgBreakPointList &dlgDirectDbg::getBreakpointList()
+void dbgArgValueEvaluator::CancelEval()
 {
-	return( m_breakpoints );
+	m_cancelled = true;
+
+	if (m_conn->GetTxStatus() == PGCONN_TXSTATUS_ACTIVE)
+		m_conn->CancelExecution();
 }
 
+dbgArgValueEvaluator::dbgArgValueEvaluator(pgConn *_conn, dlgDirectDbg *_dlg)
+	: wxThread(wxTHREAD_JOINABLE), m_conn(_conn), m_dlg(_dlg), m_cancelled(false)
+{}
